/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("carter.ui.ImportAdminMenuInitializer");

dojo.require("carter.ui.utils");
dojo.require("dojo.i18n");
dojo.require("dm.app.admin.ui.internal.pages.AdminComponentMenu");

dojo.requireLocalization("carter.ui", "EditorMessages");
dojo.requireLocalization("carter.ui", "PublisherMessages");


var messages = dojo.i18n.getLocalization("carter.ui", "EditorMessages");
var messages2 = dojo.i18n.getLocalization("carter.ui", "PublisherMessages");


/*Add import menu items to the admin page */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminComponentMenu, "addExtendedCapabilityComponentMenuItems", {
	after: function() {
		var menu = dojox.lang.aspect.getContext().instance;
		var projectId = jazz.app.context.get().itemId;
		
		menu.addTitle(messages.rhapsodyImport);
		menu.addItemByArgs({
			label: messages.defintions,
			href: carter.ui.utils.getDefinitionsViewUri(),
			icon: dojo.moduleUrl("carter.ui", "graphics/icons/definitions.gif")
		});
		menu.addItemByArgs({
			label: messages2.publish,
			href: carter.ui.utils.getNewPublishViewUri(),
			icon: dojo.moduleUrl("carter.ui", "graphics/icons/new_publish.gif")
		});
		menu.addItemByArgs({
			label: messages.manage,
			href: carter.ui.utils.getManageModelsViewUri(),
			icon: dojo.moduleUrl("carter.ui", "graphics/icons/manageModels.gif")
		});
		menu.addItemByArgs({
			label: messages.activities,
			href: carter.ui.utils.getActivitiesEditorUri(),
			icon: dojo.moduleUrl("carter.ui", "graphics/icons/activities.gif")
		});
	}
});

})();