/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("carter.ui.ImportAdminPageInitializer");

dojo.require("dojox.lang.aspect");

dojo.require("dm.app.admin.ui.internal.pages.AdminPage");
dojo.require("carter.ui.utils");
dojo.require("carter.ui.PublishWidgetController");
dojo.require("carter.ui.publisher.NewPublishEditorInput");
dojo.require("carter.ui.publisher.ManageModelsEditorInput");
dojo.require("carter.ui.editors.DefinitionsEditorInput");
dojo.require("carter.ui.editors.DefinitionEditorInput");
dojo.require("carter.ui.editors.ActivitiesEditorInput");

dojo.require("carter.ui.PublishWidgetController");

dojo.require("dojo.i18n");
dojo.requireLocalization("carter.ui", "PublisherMessages");

var messages = dojo.i18n.getLocalization("carter.ui", "PublisherMessages");

var Utils = carter.ui.utils;	
var PAGE_ID = "carter.ui.publish";
var ACTION_PREFIX = "dm.app.admin.";
var registerActions = 1;

var IMPORT_ACTIONS_LIST = [
		"viewNewPublish",
		"viewManageModels",
		"viewDefinitions",
		"viewDefinitionEditor",
		"viewActivities"
	];


rmps.ui.editor.EditorRegistry.register("carter.ui.publisher.NewPublishEditor", function(editorInput) {
	return editorInput.declaredClass == "carter.ui.publisher.NewPublishEditorInput";
});

rmps.ui.editor.EditorRegistry.register("carter.ui.publisher.ManageModelsEditor", function(editorInput) {
	return editorInput.declaredClass == "carter.ui.publisher.ManageModelsEditorInput";
});

rmps.ui.editor.EditorRegistry.register("carter.ui.editors.DefinitionsEditor", function(editorInput) {
	return editorInput.declaredClass == "carter.ui.editors.DefinitionsEditorInput";
});

rmps.ui.editor.EditorRegistry.register("carter.ui.editors.DefinitionEditor", function(editorInput) {
	return editorInput.declaredClass == "carter.ui.editors.DefinitionEditorInput";
});

rmps.ui.editor.EditorRegistry.register("carter.ui.editors.ActivitiesEditor", function(editorInput) {
	return editorInput.declaredClass == "carter.ui.editors.ActivitiesEditorInput";
});


dojo.extend(dm.app.admin.ui.internal.pages.AdminPage, {
	_refreshStatus: function() {
	//	var statusEditor = this.pageHelper.getEditor(this._importStatusEditorInput);
	//	if (statusEditor) {
	//		statusEditor.refresh();
	//	}
	}		
});

/*Add import sections to the admin page side navigation */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminPage, "createExtendedAdminPageContents", {
	after: function() {
		var self = dojox.lang.aspect.getContext().instance;
		
		var projectId = jazz.app.context.get().itemId;
		
		self._PublishViewInput = new carter.ui.publisher.NewPublishEditorInput({ projectId: projectId });
		self._ManageViewInput = new carter.ui.publisher.ManageModelsEditorInput({ projectId: projectId });
		self._DefinitionsView = new carter.ui.editors.DefinitionsEditorInput({ projectId: projectId });
		self._DefinitionEditorInput = new carter.ui.editors.DefinitionEditorInput({ projectId: projectId });
		self._ActivitiesEditorInput = new carter.ui.editors.ActivitiesEditorInput({ projectId: projectId });				
	}
});

/*Register the import actions to the admin page */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminPage, "registerExtendedActions", {
	after: function() {
		 dojox.lang.aspect.getContext().instance.registerActionsList(IMPORT_ACTIONS_LIST);		
	}
});

/*Use import controller to invoke the import registered actions */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminPage, "subscribeExtendedActions", {
	after: function() {
		var self = dojox.lang.aspect.getContext().instance;
		self._controller = new carter.ui.PublishWidgetController(self);
		self.subscribeAllActions(self._controller);
	}
});
})();