
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
 
 function noError(){return true;}
 
 function setHasInMemoryChanges(value)
 {
 	if (value == "true")
 		com_ibm_rhp_hasInMemoryChanges = true;
 	else
 		com_ibm_rhp_hasInMemoryChanges = false;
 }

(function() {
	
dojo.provide("com.ibm.rational.carter.ide.client.changesets.RhpChangesetsView");

/*######################################### */
/*These imports are required to invoke auth dialogs, and
 * users' credentials checking utils. Otherwise, the users,
 * will not be autheroized when trying to search for an element
 * even if they are already logged in */
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");

dojo.require("dijit._Templated");
dojo.require("dijit.layout._LayoutWidget");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.StackController");
dojo.require("dijit._Widget");
//vvc is missing this require
dojo.require("jazz.ui.MessageBox");
dojo.require("rmps.app.ui.internal.util.UrlUtil");
dojo.require("com.ibm.rational.carter.ide.client.connection.connectionWidget");

dojo.require("com.ibm.rational.carter.ide.client.context.contextHelper");
var contextHelper = com.ibm.rational.carter.ide.client.context.contextHelper;

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;
dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;

dojo.require("com.ibm.team.vvc.shared.web.ui.changesets.ChangesetsWidgit");

dojo.requireLocalization("com.ibm.team.vvc.shared.web.ui.changesets", "ChangesetsMessages");
var messages = dojo.i18n.getLocalization("com.ibm.team.vvc.shared.web.ui.changesets", "ChangesetsMessages");

var ContextUtils = 	com.ibm.team.vvc.shared.web.ui.context.ContextUtils;

var States = {
	Active: "IN_PROGRESS",
	Completed: "COMPLETED",
	Committed: "COMMITTED",
	Suspended: "SUSPENDED"
};

var Actions = {
		Commit: "COMMIT",
		Complete: "COMPLETE",
		Rename: "RENAME"
};

var contextRoot = net.jazz.ajax._contextRoot;
if (contextRoot.indexOf('jazz') != -1) contextRoot += '/jfs';



dojo.declare("com.ibm.rational.carter.ide.client.changesets.RhpChangesetsView", [dijit.layout._LayoutWidget, dijit._Templated], {
	widgetsInTemplate: true,
	//rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),
	templateString: dojo.cache("com.ibm.rational.carter.ide.client", "changesets/templates/RhpChangesetsView.html"),

	containerNode: null,
	tabContainer: null,
	connectionContainer:null,
	contentPane:null,

	_changesetsWidgit:null,
	

	postCreate: function(){
		this.inherited(arguments);
		//triggers the login window if needed
		if (!RhpCommunicator.login()) {
			return;
		}
		contextHelper.init(true); //it we will need vvc we'll have to set it true/ currently causes login exception on first load
		
		var deferred = RhpProjectAreaInfo.init();
		deferred.addCallback(this,this.init);
		

	},


	layout: function(){
		this._content.layout();
		this.inherited(arguments);
	},

	init: function() {
		this.startup();
		this.createConnectionWidget();
		this.layout();
	},
	
    uninitialize: function()
	{
    	if (this._changesetsWidgit) {
			this._changesetsWidgit.destroyRecursive();
			delete this._changesetsWidgit;
		}
		if (this._connectionWidget){
			this._connectionWidget.destroyRecursive();
			delete this._connectionWidget;
		}
	},


	createConnectionWidget: function() {
		if (!this._connectionWidget) {
			this._connectionWidget = new com.ibm.rational.carter.ide.client.connection.connectionWidget({
				isReadOnly:true,
			});

			this.connectionContainer.appendChild(this._connectionWidget.domNode);
			this._connectionWidget.startup();
			dojo.connect(this._connectionWidget, "_onSelectBaseline",this,this._onSelectBaseline);
			if (this._connectionWidget._currentProjectArea && this._connectionWidget._currentContext)
				this._onSelectBaseline(this._connectionWidget._currentProjectArea, this._connectionWidget._currentContext);
		} 

	},

	_constructChangesetsWidgit: function() {
		if (!this._changesetsWidgit)
		{
			this._changesetsWidgit = new com.ibm.team.vvc.shared.web.ui.changesets.ChangesetsWidgit_();
			if (this._changesetsWidgit)
			{
			    /* append the new grid to the div */
			    this._changesetsDiv.appendChild(this._changesetsWidgit.domNode);
				//this._changesetsWidgit.startup();
			    this._changesetsWidgit.resizeExplorer();
			}
		}
	},


	_onSelectBaseline: function(projectArea, baseline)
	{
		contextHelper.setContext(projectArea, baseline);
		if (projectArea && baseline)
		{
			if (this._changesetsWidgit) {
				this._changesetsWidgit.destroyRecursive();
				delete this._changesetsWidgit;
			}

			this._constructChangesetsWidgit();
		}
		
	},



});


//override changesetWidgit
dojo.declare("com.ibm.team.vvc.shared.web.ui.changesets.ChangesetsWidgit_", com.ibm.team.vvc.shared.web.ui.changesets.ChangesetsWidgit, {
	
	_constructGrid: function() {
		if (!this._grid)
		{
			this._grid = new com.ibm.team.vvc.shared.web.ui.changesets.ChangesetsTreeGrid_({
				"displayErrorMessage" : this.displayErrorMessage,
				"hideErrorMessage" : this.hideErrorMessage
			});
			
		    /* append the new grid to the div */
		    this._explorerDiv.appendChild(this._grid.domNode);
	
		    /* Call startup() to render the grid */
		    this.resizeExplorer();
		}
	},
	
	_constructToolbar:function()
	{
		if (!this._toolbar)
		{
			var toolbar = new jazz.ui.Toolbar();
			
//			var newChangesetButton = jazz.ui.toolbar.Button({
//				title: this.messages.newChangeset,
//				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/create_change.gif').uri,
//				onClick: dojo.hitch(this, function(){
//					var form = new com.ibm.team.vvc.shared.web.ui.changesets.CreateChangesetForm({
//						messages: this.messages,
//						grid: this._grid
//					});
//					form.show();
//				})
//			});
//			toolbar.addChild(newChangesetButton);
			
			toolbar.addChild(new jazz.ui.toolbar.Separator());
			
			var refreshButton = jazz.ui.toolbar.Button({
				title: this.messages.refresh,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/refresh.gif').uri,
				onClick: dojo.hitch(this, function(){
					this._grid.refresh();
				})
			});
			toolbar.addChild(refreshButton);
			
			this._toolbar = toolbar;
			this._toolbarDiv.appendChild(toolbar.domNode);
		}
	},

	
});


//override changesetWidgit
dojo.declare("com.ibm.team.vvc.shared.web.ui.changesets.ChangesetsTreeGrid_", com.ibm.team.vvc.shared.web.ui.changesets.ChangesetsTreeGrid, {
	

	_actionRegistry: { 
		changeset : [
		    // Not implemented yet         
/*				{
				isApplicable: function(node) {
					return true; 
				},
				label:  messages.addWorkItem,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/add_workitem.gif').uri,
				handler: function (node) {
					alert('TODO: add workitem');
				}
			}, 
			{
				isApplicable: function(node) {
					return node.state != States.Suspended;
				},
				label:  messages.suspend,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/suspend.gif').uri,
				handler: function (node) {
					alert('TODO: suspend');
				}
			},
			{
				isApplicable: function(node) {
					return node.state == States.Suspended;
				},
				label: messages.activate,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/activate.gif').uri,
				handler: function (node) {
					alert('TODO: activate');
				}
			},*/
		    {
				isApplicable: function(node) {
					return node.state != States.Completed && node.state != States.Committed ;
				},
				label:  messages.discard,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/delete.gif').uri,
				handler: function (node) {
					this._discard(node.uri);
				}
			},              
			{
				isApplicable: function(node) {
					return node.state != States.Committed;
				},
				label:  messages.share,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/share_change.gif').uri,
				handler: function (node) {
					this._performAction(node, Actions.Commit);
				}
			},
			/*{
				isApplicable: function(node) {
					return node.state != States.Completed;
				},
				label: messages.complete,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/complete.gif').uri,
				handler: function (node) {
					this._performAction(node, Actions.Complete);
				}
			},*/
//			{
//				isApplicable: function(node) {
//					return node.state != States.Committed;
//				},
//				label: messages.rename,
//				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/rename.gif').uri,
//				handler: function (node) {
//					this._performAction(node, Actions.Rename);
//				}
//			}
		],
		/*resource: [
			{
				isApplicable: function(node) {
					return true; 
				},
				label:  messages.move,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/move.gif').uri,
				handler: function (node) {
					alert('TODO: move');
				}
			},              
			{
				isApplicable: function(node) {
					return true;
				},
				label:  messages.open,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/open.gif').uri,
				handler: function (node) {
					alert('TODO: open resource');
				}
			}
		],*/
		workitem: [
			{
				isApplicable: function(node) {
					return true; 
				},
				label:  messages.unlink,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/unlink.gif').uri,
				handler: function (node) {
					alert('TODO: disassociate work item');
				}
			},              
			{
				isApplicable: function(node) {
					return true;
				},
				label:  messages.open,
				imgSrc: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'graphics/open.gif').uri,
				handler: function (node) {
					alert('TODO: open work item');
				}
			}
		],
	},
	
	_performAction: function(node, action)
	{
		var resourceUri = node;
		if (node.uri)
			resourceUri = node.uri;
			
		//get the equivalent editing session
		var esUri = this._getEditingSession(resourceUri);
		if (!esUri)
		{
			//TODO: Add notify user
			return;
		}
		var headers;
		var data;
		if (action == Actions.Commit || action == Actions.Complete ){
			headers = {
					"Content-Type" : "text/plain",
			};
			data = "{\"action\" : \"commit\"}";
		} 
		else if (action == Actions.Rename) {
			var name = prompt(messages.renamePrompt, node.title);
			if (!name || name == node.title) {
				// if user has cancelled the input prompt
				return;
			}
			headers = {
					"Content-Type" : "text/plain"
			};				
			data = "{\"action\" : \"setDescription\", \"value\" : \"" +	name + "\"}";
		}
		else
			return;

		jazz.client.xhrPost({
			handleAs: 'text',
			headers: headers,
			sync: true,
			url: esUri, //$NON-NLS-1$
			postData: data,

			load: dojo.hitch(this, function(response, ioArgs) {
				this._grid.store.fetchItemByIdentity({
					identity:resourceUri,
					onItem:dojo.hitch(this._grid.store, function(item){
						this.setValue(item, 'state', "COMPLETED");
						this.save();
					})
				});
				if (action == Actions.Commit || action == Actions.Complete )
					this._onCommitChangeset(esUri,resourceUri);
				this.refresh();

			}),
			
			error: dojo.hitch(this, function(e) {
				console.log(e);
				if (this.displayErrorMessage)
					this.displayErrorMessage("Error: "+e.message);
				else
					alert('error '+e.message);
			})
		});
		 
	},

	_discard: function(node)
	{
		//get the equivalent editing session
		var resourceUri = node;
		if (node.uri)
			resourceUri = node.uri;
		
		var esUri = this._getEditingSession(resourceUri);
		if (!esUri)
		{
			//TODO: Add notify user
			return;
		}
		this._onBeforeDiscardChangeset(esUri,resourceUri);
		jazz.client.xhrDelete({
			handleAs: 'text',
			sync: true,
			url: esUri, //$NON-NLS-1$
			content: {
				
			},

			load: dojo.hitch(this, function(response, ioArgs) {
				this._grid.store.fetchItemByIdentity({
					identity:resourceUri,
					onItem:dojo.hitch(this._grid.store, function(item){
						this.deleteItem(item);
						this.save();
					})
				});
				this._onDiscardChangeset(esUri,resourceUri);
			}),
			
			error: dojo.hitch(this, function(e) {
				console.log(e);
				if (this.displayErrorMessage)
					this.displayErrorMessage("Error: "+e.message);
				else
					alert('error '+e.message);
			})
		});
	},
	
	_getData: function()
	{
		this.data = null;
		
		if (this.hideErrorMessage)
			this.hideErrorMessage();
		
		var contextUri = ContextUtils.getContextUri();
		
		jazz.client.xhrGet({
			handleAs: 'json',
			sync: true,
			url: contextRoot + '/vvcshared/proxy', //$NON-NLS-1$
			"headers" : {
				"vvc_servicePath" : "/changesets/query"
			},
			content: {
				"includeCreated" : "true",
				"configuration" : contextUri
			},

			load: dojo.hitch(this, function(result) {
				this.data = result;
			}),
			
			error: dojo.hitch(this, function(e) {
				console.log(e);
				if (this.displayErrorMessage)
					this.displayErrorMessage("Error: "+e.message);
				else
					alert('error '+e.message);
			})
		});
		
		return this.data; 
	},
	
	_onCommitChangeset: function(editingSessionUri, changesetUri) {
		var params = {
				editingSessionUri: editingSessionUri,
				changesetUri: changesetUri
		};
		RhpCommunicator.notifyRhapsody({
			cmd: "onCommitEditingSession",
			params: [dojo.objectToQuery(params)],
		});

	},
	
	
	_onBeforeDiscardChangeset: function(editingSessionUri, changesetUri) {
		var params = {
				editingSessionUri: editingSessionUri,
				changesetUri: changesetUri
		};
		RhpCommunicator.notifyRhapsody({
			cmd: "beforeDiscardEditingSession",
			params: [dojo.objectToQuery(params)],
		});

	},
	
	_onDiscardChangeset: function(editingSessionUri, changesetUri) {
		var params = {
				editingSessionUri: editingSessionUri,
				changesetUri: changesetUri
		};
		RhpCommunicator.notifyRhapsody({
			cmd: "onDiscardEditingSession",
			params: [dojo.objectToQuery(params)],
		});

	},
 

	
	
	_getEditingSession: function(vvcChangesetUri) {
		//https://davidhir-tp.haifa.ibm.com:9444/dm/carter/changesets?command=getEditingSessionUri&projectId=_Z8dCd6WuEeG2UOZVqk94AA&vvcChangesetUri=https%3A%2F%2Fdavidhir-tp.haifa.ibm.com%3A9445%2Fvvc%2Fchangesets%2F21
		var uri = "/dm/carter/changesets?command=getEditingSessionUri&vvcChangesetUri=" + encodeURI(vvcChangesetUri);
		
		var args = {
				handleAs: 'text',
				url: uri,
				sync: true,
				load: function(response, ioArgs) {
					if (response)
						return response;
					return null;
					
				},
				error: function(response, ioArgs) {
					rmps.core.error.createXhrError(ioArgs).dispatch();
				}
		};
		var deferred =  jazz.client.xhrGet(args);
		var esUri = deferred.ioArgs.xhr.responseText;
		return esUri;
	}, 
	
	

});
})();
