/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.carter.ide.client.connection.connectionWidget");


/*######################################### */
// declare dependencies on other Dojo modules
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.ComboBox");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dojo.data.ItemFileReadStore");

dojo.require("rmps.ui.SimpleButton");
dojo.require("rmps.app.ui.internal.context.ContextSelection");

dojo.require("com.ibm.rational.carter.ide.client.connection.RhpConnectionInfo");
dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
dojo.require("rmps.core.streams.StreamClient");

dojo.require("dijit.form.CheckBox");
var StreamClient = rmps.core.streams.StreamClient;
dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;


var ConnectionInfo = com.ibm.rational.carter.ide.client.connection.RhpConnectionInfo;
var ProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;

dojo.require("rmps.app.ui.internal.util.UrlUtil");
var UrlUtil= rmps.app.ui.internal.util.UrlUtil;

dojo.require("com.ibm.rational.carter.ide.client.util.rhpUtils");
var rhpUtils = com.ibm.rational.carter.ide.client.util.rhpUtils;

dojo.require("com.ibm.rational.carter.ide.client.context.contextHelper");
var contextHelper = com.ibm.rational.carter.ide.client.context.contextHelper;




dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");


dojo.require("rmps.core.user.UserClient");
dojo.require("rmps.core.baseline.Baseline");
dojo.require("rmps.core.baseline.BaselineClient");
dojo.require("rmps.core.streams.StreamClient");
dojo.require("rmps.core.changesets.ChangesetClient");
dojo.require("rmps.core.util.ContextUtils");
dojo.require("rmps.core.changesets.Changeset");
//dojo.require("rmps.core.util.ContextTypes");


dojo.requireLocalization("rmps.app.ui.internal.context", "ContextSelectionMessages");

var BaselineClient= rmps.core.baseline.BaselineClient;
var StreamClient= rmps.core.streams.StreamClient;
var ChangesetClient= rmps.core.changesets.ChangesetClient;
var ContextUtils= rmps.core.util.ContextUtils;
var Changeset = rmps.core.changesets.Changeset;
var CONTEXT_TYPES = rmps.core.util.ContextTypes;

// declare and implement the widget "class"
dojo.declare("com.ibm.rational.carter.ide.client.connection.connectionWidget", [ dijit._Widget, dijit._Templated ], {

	rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),    
	templateString: dojo.cache("com.ibm.rational.carter.ide.client", "connection/templates/connectionWidget.html"),
	
	_currentConnection: null,
	_currentProjectArea: null,
	_currentContext: null,
	
	contextSelection: null,
	projectSelector: null,
	connectionSelector: null,
	
	_readOnlyCheckboxContainer: null, 
	
	_readOnlyCheckBox: false,
	readOnlyContainer: null,
	isReadOnly: false,

	_oldHash: null,
	
	postCreate: function() {

		this.inherited(arguments);
		this.initConnections();
		this.initFromFragment();
		this.initProjectAreas();
		this._oldHash = dojo.queryToObject(dojo.hash());
		dojo.subscribe("/dojo/hashchange", this, "onHashChange");

		//this.readOnlyContainer.hidden = true;
		this.updateReadOnly(this.isReadOnly);
//		this._readOnlyCheckBox = new dijit.form.CheckBox({
//			checked: this.isReadOnly,
//			onChange: dojo.hitch(this, this.updateReadOnly)
//		});
//		this._readOnlyCheckboxContainer.appendChild(this._readOnlyCheckBox.domNode);
//		this._readOnlyCheckBox.startup();

	},
		
	destroy: function(){
		if(this._connectionWidget){
		   this._connectionWidget.destroyRecursive();
		   delete this._connectionWidget;
		}
		if(this._readOnlyCheckBox){
			   this._readOnlyCheckBox.destroyRecursive();
			   delete this.	_readOnlyCheckBox;
			}


		this.inherited(arguments);
	},	
	
	
	
	onHashChange: function(hash) {
		var newHash = (hash != null)? hash : dojo.hash();
		var newHashObj = dojo.queryToObject(newHash);

		if (newHashObj.projectName != this._oldHash.projectName
			|| newHashObj["rmps.context"] != this._oldHash["rmps.context"])
		{
				this._currentProjectArea = RhpProjectAreaInfo.getProjectAreaByName(newHashObj.projectName);
				this._currentContext = rhpUtils.getFragment("rmps.context");
				if (this._currentProjectArea)
				{
					this._setSelection(this.projectSelector,this._currentProjectArea.itemId);
					if (this._currentContext)
						this.createContextSelection(this._currentContext);
				}
		}
		this._oldHash = dojo.mixin({}, newHashObj);//dojo.clone(newHashObj);
		
	},

	onResourceChange: function() {
		//this.initProjectAreas();
	},
	
	destroy: function() {
		if (this.projectSelector != null && this.projectSelector.destroy != null )
			this.projectSelector.destroy();
		if (this.connectionSelector != null && this.connectionSelector.destroy != null )
			this.connectionSelector.destroy();

		this.inherited(arguments);
	},

	initFromFragment: function() {

		if (!this._currentProjectArea)
		{
			var projectName = rhpUtils.getFragment("projectName");
			this._currentProjectArea = RhpProjectAreaInfo.getProjectAreaByName(projectName);
		}
		if (this._currentProjectArea && ! this._currentContext)
			this._currentContext = rhpUtils.getFragment("rmps.context");
	
	},
	initProjectAreas: function() {
		
		var projects = ProjectAreaInfo.getProjectAreas();
		var first = null;
		dojo.forEach(projects,function(proj) {
			this._addOption(this.projectSelector,proj.name,proj.itemId);
			if (!first)
				first = proj;
			
		},this);
		if (this._currentProjectArea!=null)
			this._setSelection(this.projectSelector,this._currentProjectArea.itemId);
		else
		{
			this._currentProjectArea = first;
		}
	

		if (this._currentProjectArea)
		{
			if (this._currentContext)
				this.createContextSelection(this._currentContext);
			else
				this.handleProjectSelection();
		}
	},
	
	handleProjectSelection: function(event)
	{
		if (event)
		{
			var selected = event.target.options[event.target.selectedIndex].value;
			this._currentProjectArea = RhpProjectAreaInfo.getProjectAreaById(selected);
		}
		if (this._currentProjectArea)
		{
			var defaultStreamGet = StreamClient.getDefaultStream(this._currentProjectArea.itemId);
			defaultStreamGet.addCallback(dojo.hitch(this, this.createContextSelection));
			this._onSelectProject(this._currentProjectArea.name);
		}
	},
	
	//should be overridden by clients
	_onSelectProject: function(projectName)
	{
		
	},

	
	createContextSelection: function(streamUri)
	{
		this._currentContext = streamUri;
		if (!this.contextSelection)
		{
			//have first to set env projectId, otherwise context selection will be used with old projectId
			contextHelper.setProjectArea(this._currentProjectArea);
			this.contextSelection = new rmps.app.ui.internal.context.ContextSelection_({
				projectId: this._currentProjectArea.itemId,
				context: this._currentContext,
				disabled: false,
				contextFilter: "completed",
				contextComparator: function (a, b) {
					if (!a || !b)
						return 0;
					var contextTypeA = ContextUtils.getContextType(a.uri);
					var contextTypeB = ContextUtils.getContextType(b.uri);
					if (contextTypeA == CONTEXT_TYPES.WORKSPACE && contextTypeB != CONTEXT_TYPES.WORKSPACE)
						return -1;
					else if (contextTypeA != CONTEXT_TYPES.WORKSPACE && contextTypeB == CONTEXT_TYPES.WORKSPACE)
						return 1;
					else if (contextTypeA == CONTEXT_TYPES.SNAPSHOT && contextTypeB != CONTEXT_TYPES.SNAPSHOT)
						return -1;
					else if (contextTypeA != CONTEXT_TYPES.SNAPSHOT && contextTypeB == CONTEXT_TYPES.SNAPSHOT)
						return 1;
					return a.timestamp < b.timestamp ? 1 : a.timestamp == b.timestamp ? 0 : -1;
					},
				handleSelection: dojo.hitch(this, this.handleContextSelection),
				templateString: '<span>' +
				'<select dojoAttachPoint="sRs" dojoAttachEvent="onchange: _onChange">' +
				'</select>' +
				'</span>',

			});
			//this.connect(this.contextSelection, 'onChange', dojo.hitch(this, this._onbaselineChanges));
			this._baselineSelect.appendChild(this.contextSelection.domNode);
			this.updateReadOnly(this.isReadOnly);

		}
		else
		{
			this.contextSelection.projectId = this._currentProjectArea.itemId;
			this.contextSelection._selectedContext = this._currentContext;
			this.contextSelection.refresh();
		}
		this._onSelectBaseline(this._currentProjectArea,this._currentContext);

	},
	
	

	handleContextSelection: function (streamUri)
	{
		this._currentContext = streamUri;
		this._onSelectBaseline(this._currentProjectArea,this._currentContext);	
		
	},

	//should be overridden by clients
	_onSelectBaseline: function(projectArea, baseline)
	{
		var y = 15;
		
	},
	
	initConnections: function() {
	
		var cons = ConnectionInfo.getConnectionsArray();
		var connOptions = this.createConnectionOptions(cons);
		this._currentConnection = ConnectionInfo.getCurrentConnection(cons);
		connOptionsJSon = {

			identifier: "value",
			label: "name",
			items: connOptions,
		}
		

		this.connectionSelector = new dijit.form.ComboBox({
			store: new dojo.data.ItemFileReadStore({
                data: connOptionsJSon
            }),
            autoComplete: true,
            //style: "width: 300px;",
            id: "connectionSelector",
			value: this._currentConnection.url,
        }, this.connectionSelector);
		
		dojo.connect(this.connectionSelector,'onChange',this,this._localOnConnectionChange);
		
		var button = new rmps.ui.SimpleButton({
					label: this.rhpMessages.Select,
					onClick: dojo.hitch(this, this._onSelectConnection)
				});
		this.connectionContainer.appendChild(button.domNode);
		
	},
	
	_localOnConnectionChange: function(conn) {

	},
	
	_onSelectConnection: function()
	{
		
		var connection = null;
		
		if (this.connectionSelector != null)
			connection = this.connectionSelector.attr('item');
		
		if (connection!=null)
			connection = connection.value[0];
		else
		{
			connection = "url=" + this.connectionSelector.attr('value')+"&username=&password=";
		}
		
		if (connection != null)
		{
			var conn = dojo.queryToObject(connection);
			
			RhpCommunicator.notifyRhapsody({
					cmd: "selectConnection",
					params: [((conn.url!=null)?conn.url:""),
							((conn.username!=null)?conn.username:""),
							((conn.password!=null)?conn.password:"")]
				});
		}
	},

	createConnectionOptions: function(connections)
	{
		var connectionsOptions = [];
		dojo.forEach(connections,function(conn) {
			var connectionOption = {name:conn.url, 
								value:dojo.objectToQuery(conn)};
			connectionsOptions.push(connectionOption);
			},this);
			return connectionsOptions;			
		},
	
		createProjectsOptions: function(projects){
			var projectsOptions = [];
			dojo.forEach(projects,function(proj) {
				var projectsOption = {name:proj.name, 
										value:proj.itemId};
				projectsOptions.push(projectsOption);
			},this);
			return projectsOptions;			
		},	
	
	/**
	 * Adds an option to the end of the dropdown list with the given label and value and returns the new option
	 */
	_addOption: function(selection, label, value) {
		var option = dojo.create("option", { "value" : value }, selection, null);
		var text = dojo.doc.createTextNode(label);
		option.appendChild(text);
		return option;
	},

	_setSelection: function(selection, value) {
		for (var i = 0; i< selection.options.length; i++) {
		  if (selection.options[i].value === value) {
			  selection.options[i].selected = true;
			  return true;
		  }
		}
		return false;
	},
	
	updateReadOnly: function(checked) //projectAreaId,streamId)
	{

		this.isReadOnly = checked;
		
		 this.connectionSelector.disabled = 
		 this.projectSelector.disabled = this.isReadOnly;
		 if (this.contextSelection)
			 this.contextSelection.sRs.disabled = this.isReadOnly;
		
	}
});
dojo.declare("rmps.app.ui.internal.context.ContextSelection_", rmps.app.ui.internal.context.ContextSelection, {
	
	/**
	 * Refreshes the list of contexts, keeping the current selection.
	 */
	 refresh: function() {
		 
		var deferreds= [];
		var snapshots= [];
		var workspace;
		var workspaces = [];
		var changesetCtxt;
		var parent= null;
		var activeCtxt= this._selectedContext;
		var i;
		
		if (this._deferred) {
			//if a refresh is currently in progress, just wait for it to finish
			return;
		}

		//remove existing options
		for (i = this.sRs.options.length-1; i >= 0 ; i--) {
			this.sRs.remove(i);
		}

		//add "Loading..." text
		this._addOption(this.messages.loading, null).selected = true;
		var contextType = ContextUtils.getContextType(this._selectedContext);
		if (contextType === rmps.core.util.ContextTypes.CHANGESET){
			activeCtxt = jazz.app.context.get().baseline;
		} else if ( contextType === rmps.core.util.ContextTypes.SNAPSHOT){
			parent = true;
		}

		var deferredStream = StreamClient.getStream(activeCtxt, parent);
		deferredStream.addCallback(this, function (stream) {
			workspace= stream;
		});
		deferreds.push(deferredStream);

		var deferredStreams = StreamClient.getStreams(this.projectId);
		deferredStreams.addCallback(this, function (streams) {
			workspaces = workspaces.concat(streams);
		});
		deferreds.push(deferredStreams);

		var deferredSnapshot = BaselineClient.getBaselines(this.baselineFilter, this.projectId);
		deferredSnapshot.addCallback(this, function (baselines) {
			snapshots= snapshots.concat(baselines);
		});
		deferreds.push(deferredSnapshot);	
		
		this._deferred = new dojo.DeferredList(deferreds);
		this._deferred.addCallback(this, function () {
			// getting the changesets (including not committed ones)
			var deferredChangeset = ChangesetClient.getChangesetsForUser(jazz.app.currentApplication.config.user.uri, true);
			deferredChangeset.addCallback(this, function (changesets) {			
				// Building the contexts list - only not committed changesets should be displayed
				var validChangesets = [];
				for (i = 0; i<changesets.length; i++) {
//					if (changesets[i].state != Changeset.States.COMMITTED){
					if (changesets[i].state != rmps.core.changesets.ChangesetStates.COMMITTED){					
						validChangesets.push(changesets[i]);
					}
				}				
				var contexts= validChangesets;
				contexts = contexts.concat(workspaces);
				var strSnapshots = workspace.snapshots;

				for (i = 0; i<snapshots.length; i++) {
					if (dojo.indexOf(strSnapshots, snapshots[i].uri)>-1){
						contexts.push(snapshots[i]);
					}
				}			
			
				//remove "loading..." text
				this.sRs.remove(0);

				if (this.contextComparator) {
					contexts.sort(this.contextComparator);
				}

				var option;
				for (i = 0; i<contexts.length; i++) {
					option = this._addOption(contexts[i].name, contexts[i].uri);

					if (this.showTooltip) {
						option.title = this.messages.created + " "
						+dojo.date.locale.format(contexts[i].timestamp, {formatLength: "medium"});
					}
				}

				if (!this._setSelection(this._selectedContext)) {
					//add a blank entry to the top of the list to represent the bad selection, and select it
					option = dojo.create("option", { value : this._selectedContext });
					option.selected = true;
					try {
						this.sRs.add(option,this.sRs.options[0]); // standards compliant
					} catch(ex) {
						this.sRs.add(option,0); // IE only
					}
					rmps.core.error.create(this.messages.error_selection_does_not_exist).dispatch();
				}
			});

		});
		this._deferred.addErrback(this, dojo.hitch(this, function(error) {
			//error fetching contexts; report it
			if (!dojo._isDocumentOk(this._deferred.ioArgs.xhr)) {
				rmps.core.error.createXhrError(this._deferred.ioArgs).dispatch();
			} else {
				rmps.core.error.createError(error).dispatch();
			}
		}));
		this._deferred.addBoth(this, function() {
			delete this._deferred;
		});
	},
	
	
});