/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rational.carter.ide.client.context.contextHelper");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.ui.RemoteChooserResponder");
dojo.require("rmps.app.core.internal.Workarounds");
dojo.require("rmps.core.BackendScr");

dojo.require("rmps.core.streams.StreamClient");
dojo.require("rmps.app.ui.internal.util.UrlUtil");
dojo.require("rmps.core.util.ContextUtils");
dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");
dojo.require("rmps.core.RootServices");

var StreamClient = rmps.core.streams.StreamClient;
var UrlUtil= rmps.app.ui.internal.util.UrlUtil;
var ContextUtils = com.ibm.team.vvc.shared.web.ui.context.ContextUtils;
dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;

//dojo.require("com.ibm.team.vvc.server.core.ui.internal.util.PageUtil");
//var PageUtil = com.ibm.team.vvc.server.core.ui.internal.util.PageUtil;




var rhp_review_workBench = {
		registerOnBeforeUnloadHandler: function(){
			
		},
		unregisterNavigateAwayHandler: function(){
			
		},
		showMessage: function() {
			
		},
		hideMessageArea: function() {
			
		},
		setTitle: function() {
			
		},
		setPageDirty: function() {
		
		},
		currentPageId: "com.ibm.rational.carter.ide.client.helper.contextHelper"
	};
	
com.ibm.rational.carter.ide.client.context.contextHelper = {
		
	initialized: false,
	_currentUser: null,
	_setVVCSpace:false,
	_rootVvcUri: null,
	
	setContext: function(projectArea,baseline) {
		
		this.setProjectArea(projectArea);
		if (baseline != null)
			this.setContextActually(baseline);
		else
		{
			defaultStreamGet = StreamClient.getDefaultStream();
			defaultStreamGet.addCallback(this.setContextActually(streamUri));
		}
		
		RhpCommunicator.notifyRhapsody({
			cmd: "projectareaselected",
			params: [(projectArea != null)?projectArea.name:null,baseline],
		});

	},
	
	setContextActually: function(streamUri) {
		jazz.app.context.get().baseline = streamUri;
		if (this._setVVCSpace == true)
		{
			var deferred = this._getSpace(streamUri);
			if (deferred) {
				deferred.addCallback(dojo.hitch(this, function (ioArgs) {
					com.ibm.team.vvc.shared.web.ui.context.ContextUtils.setSpace(ioArgs.xhr.getResponseHeader("Location"));
					var d2 = this._getConfiguration();
					d2.addCallback(dojo.hitch(this, function (configuration) {
						com.ibm.team.vvc.shared.web.ui.context.ContextUtils.setCurrentContext(configuration);
						//Inform anyone that's interested that we're done initializing the context.
						dojo.publish("vvc.context_initialized", [configuration]);
						}));
				}));
			}
		}
	},
	
	_getConfiguration: function() {
		var contextUri = rmps.core.util.ContextUtils.getCurrentContextURI();
		var changesetUri = rmps.core.util.ContextUtils.getCurrentChangesetURI();
		var link = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "queryvvc");
		if (changesetUri) {
			link += "/configfromchangeset?context=" + escape(changesetUri);
		}else if (rmps.core.util.ContextUtils.isSnapshot(contextUri)) {
			link += "/configfromsnapshot?context=" + escape(contextUri);
		} else {
			link += "/configfromworkspace?context=" + escape(contextUri);
		}
		var args = {
				handleAs: 'json',
				url: link,
				sync: true,
				load: function(response, ioArgs) {
					return response;
				},
				error: function(response, ioArgs) {
					rmps.core.error.createXhrError(ioArgs).dispatch();
				}
		};
		return jazz.client.xhrGet(args);
	}, 
	
	setProjectArea: function(projectArea) {
		if (projectArea != null)
		{
			dojo.getObject("currentApplication", true, jazz.app).context = projectArea.url;
			dojo.getObject("currentApplication", true, jazz.app).applicationContext = projectArea;
			jazz.app.context.set(projectArea);
			//Todo
			jazz.app.currentApplication.applicationContext.uri = jazz.app.currentApplication.applicationContext.url;
			dojo.getObject("net.jazz.ajax.ui.PlatformUI",true);

			
		}
		this.init();
		

	},
	
	setUser: function(user)
	{
		if (user != null)
		{
			this._currentUser = user;
			this._currentUser.userId = this._currentUser.id;
			dojo.getObject("currentApplication", true, jazz.app);
			dojo.getObject("config", true, jazz.app.currentApplication).user = user;
		}
		this.init();
	},
	
	init: function(setVVCSpace) {
		
		if (this.initialized)
			return;
		else
			this.initialized = true;
		if (setVVCSpace == true)
			this._setVVCSpace = true; 
		
		net.jazz.ajax.ui.PlatformUI.getWorkbench = function(){
			return rhp_review_workBench;
		}
		jazz.client.xhrGet({
			url: rmps.core.BackendScr.get().getUriForPath([
				{namespace: rmps.core.Namespaces.JUENTRY, name: "JTSApplicationAdminLinksService"},
				{namespace: rmps.core.Namespaces.JD_1_0,name: "service"}
			]),
			headers: {
				"Accept": "application/rdf+json",
				"X-ibm-rmps-internal": "true"
			},
			handleAs: "json",
			sync: true,
			load: dojo.hitch(this, function(response) {
				this.processTemplateManagementUrl= response.processTemplateManagement.url;
				jazz.app.context.get().applicationId= UrlUtil.getParamater(this.processTemplateManagementUrl, UrlUtil.OWNNING_APPLICATION_KEY);
			})
		});
		
		this._cacheVvcRootUri();
		
		
		
		
	
	},
	
	_cacheVvcRootUri: function()
	{
		if (!this._setVVCSpace)
			return;
		// '/queryvvc/vvcurl' has to exist on the hosted application.
		var args = {
			handleAs: 'json',
			url: net.jazz.ajax.contextRoot() + '/queryvvc/vvcurl', //$NON-NLS-1$
			load: function(response, ioArgs) {
				var location = deferred.ioArgs.xhr.getResponseHeader("Location");
				if (deferred.ioArgs.xhr.status == 200 && location) {
					this._rootVvcUri = location;
					if (this._rootVvcUri && this._rootVvcUri.charAt(this._rootVvcUri.length-1)=="/") {
						this._rootVvcUri = this._rootVvcUri.substring(0, this._rootVvcUri.length-2);
					}
					//net.jazz.ajax.contextRoot = this.getVVCUrl;
				} else {
					//console.log('error', response);
					//this.displayErrorMessage("Invalid Response -- VVC Location not specified. (Status:"+deferred.ioArgs.xhr.status+")");
				}
			}
		};
		var deferred =  jazz.client.xhrGet(args);
	},
	getVVCUrl: function() {
			return this._rootVvcUri;
	},
	
	_getSpace: function(contextUri) {
		if (!contextUri) {
			return null;
		}
		var link = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "queryvvc");
		if (rmps.core.util.ContextUtils.isSnapshot(contextUri)) {
			link += "/spacefromsnapshot?context=" + escape(contextUri);
		} else {
			link += "/spacefromworkspace?context=" + escape(contextUri);
		}

		var args = {
			url: link,
			sync: true,
			load: function(response, ioArgs) {
				return ioArgs;
			},
			error: function(response, ioArgs) {
				rmps.core.error.createXhrError(ioArgs).dispatch();				
			}
		};
		return jazz.client.xhrGet(args);
	},
	
};

// the 2 functions below are copied from PageUtils.js
ContextUtils.getContextUri = function() {
	var uri = null;
	var space = ContextUtils.getCurrentContext();
	if (space)
		uri = space.uri;
	return uri;
};

})();


