/*******************************************************************************
* Licensed Materials - Property of IBM
* Copyright IBM Corp. 2010.  All Rights Reserved.
* 
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*******************************************************************************/
// declare the Dojo module
dojo.provide("carter.ui.editors.DisabledPageWidget");

// Dojo requirements
dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

//jazz/kenton requirements
dojo.require("jazz.client.xhr");
dojo.require("rmps.ui.CollapsibleSection");

// Carter reuqirements:
dojo.requireLocalization("carter.ui", "EditorMessages");

// globals:
var editorMessages = dojo.i18n.getLocalization("carter.ui", "EditorMessages");


dojo.declare("carter.ui.editors.DisabledPageWidget", [dijit._Widget, dijit._Templated], {

	widgetsInTemplate: true,
	messages: editorMessages,
	msgTitle: null,
	errMessageString: null,
	
	templateString: '<div>' + 
		'<div dojoType="rmps.ui.CollapsibleSection" dojoAttachPoint="_titleSection" collapsible="false"></div>' +
			'<table>' +
				'<tr>' +
					'<td dojoAttachPoint="_errMessage">${messages.editingActive}</td>' +
				'</tr>' +
			'</table>' +
		'</div>',
	
	constructor: function(arguments){
		if( arguments != null) {
			this.msgTitle = arguments.title;
			this.errMessageString = arguments.errMessageString;	
		}
		
		if( this.msgTitle == null )
			this.msgTitle = this.messages.importDisabled;
	},
	
	postCreate: function() {		
		var titleNode = dojo.create("span");
		titleNode.appendChild(dojo.doc.createTextNode(this.msgTitle));
		this._titleSection.setPrimaryTitle(titleNode);
		if( this.errMessageString )
			this._errMessage.innerHTML = this.errMessageString;
	}
});