/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("carter.ui.editors.Domain");

dojo.require("rmps.core.resource.Resource");
dojo.require("rmps.core.user.UserClient");
dojo.require( "rmps.core.Enum" );
dojo.require("carter.ui.utils");

var Utils = carter.ui.utils;


// Carter reuqirements:
dojo.requireLocalization("carter.ui", "EditorMessages");
dojo.require("carter.ui.utils");

var messages = dojo.i18n.getLocalization("carter.ui", "EditorMessages");

var UserClient = rmps.core.user.UserClient;

dojo.declare("carter.ui.editors.Domain", rmps.core.resource.Resource, {

	internalName: null,
	displayName: null,
	
	contentType: "application/rdf+json",
	
	constructor: function() {	
	},
		
	toRdfJson: function() {
	},

	parseRdfJson: function(rdf){
				
		if( rdf[Utils.RDF_DOMAINNAME] ) {
			this.internalName = rdf[Utils.RDF_DOMAINNAME][0].value;
			if( this.internalName == null )
				this.internalName = Utils.DOMAINNAME_RHAPSODY;
						
			this._SetDisplayName();
		}			
	},
	
	_SetDisplayName: function() {		
		if( this.internalName == Utils.DOMAINNAME_RHAPSODY ){
			this.displayName = messages.doaminRahpsody;
		}
		else if( this.internalName == Utils.DOMAINNAME_SIMULINK ){
			this.displayName = messages.doaminSimulink;
		}
		else {
			this.displayName = messages.doaminUnknown;
		}
	}
});

})();
