/*******************************************************************************
* Licensed Materials - Property of IBM
* Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
* 
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*******************************************************************************/
(function() {
    dojo.provide("carter.ui.grid.GridHelper");

	dojo.require("dojo.i18n");
    dojo.require("jazz.client.xhr");
    dojo.require("carter.ui.RootServices");
	dojo.require( "carter.ui.grid.GridEditor" );
	dojo.require( "carter.ui.error" );
		
	dojo.requireLocalization("carter.ui", "GridEditorHelperMessages");
	var messages = dojo.i18n.getLocalization("carter.ui", "GridEditorHelperMessages");

	var REQUEST_PATH = carter.ui.RootServices.getUri(carter.ui.Namespaces.CARTER, "matrix");

	dojo.declare("carter.ui.grid.GridHelper", null, {
	
		_editor: null,
		_resourceInfo: null,
		_deferred: null,
		
		constructor: function(editor, resourceInfo) {
			this._editor = editor;
			this._resourceInfo = resourceInfo;
		},
		
		createtab : function() {
		
			this._deferred = this.createrequest();
			
			this._deferred.addCallback(this, function(matrixType) {
			
				
				if (matrixType!=null) 
				{
					var title = null;
					if (matrixType=="TABLE") {
						title = messages.table;
					}
					
					if (matrixType=="MATRIX") {
						title = messages.matrix;
					}
				
					if (title) { 
						this._editor.addTab("rhpgrid", title, "carter.ui.grid.GridEditor",
						{
							resourceInfo: this._resourceInfo,
							editor: this._editor,
							gridType: matrixType
						},0);
						
						this._editor.selectTab("rhpgrid");
					}
				}
			});
			
			this._deferred.addErrback(this, function(error) {				
				var errMsg = carter.ui.error.getCarterError(this._deferred.ioArgs);
				if( errMsg != null && this._editor != null){
					this._editor.showErrorMsg(errMsg);
					return;
				}
				if (!dojo._isDocumentOk(this._deferred.ioArgs.xhr)) {
					carter.ui.error.createXhrError(this._deferred.ioArgs).dispatch();
				} else {
					carter.ui.error.createError(error).dispatch();
				}
			});
			
			this._deferred.addBoth(this, function() {
				delete this._deferred;
			});
		}
	});
})();
