
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
 
 function noError(){return true;}
 
(function() {
	dojo.provide("com.ibm.rational.carter.ide.client.links.RhpLinkWidget");

/*######################################### */
/*These imports are required to invoke auth dialogs, and
 * users' credentials checking utils. Otherwise, the users,
 * will not be autheroized when trying to search for an element
 * even if they are already logged in */
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");

dojo.require("dijit._Templated");
dojo.require("dijit.layout._LayoutWidget");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.StackController");
dojo.require("dijit._Widget");

dojo.require("jazz.ui.SimpleToolbar");
dojo.require("rmps.ui.SimpleButton");


dojo.require("com.ibm.rational.carter.ide.client.connection.connectionWidget");
dojo.require("rmps.app.ui.internal.editors.views.Links");
dojo.require("com.ibm.rational.carter.ide.client.links.RhpLinks");
dojo.require("com.ibm.rational.carter.ide.client.header.headerWidget");


dojo.require("rmps.ui.common.TabContainer");

dojo.require("com.ibm.rational.carter.ide.client.context.contextHelper");
contextHelper = com.ibm.rational.carter.ide.client.context.contextHelper;

dojo.require("rmps.core.resource.ResourceInfoClient");
ResourceInfoClient = rmps.core.resource.ResourceInfoClient;

dojo.require("com.ibm.rational.carter.ide.client.util.rhpUtils");
var rhpUtils = com.ibm.rational.carter.ide.client.util.rhpUtils;


dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;

dojo.requireLocalization("rmps.ui.common", "CommonMessages");
var commonMessages = dojo.i18n.getLocalization("rmps.ui.common", "CommonMessages");


dojo.declare("com.ibm.rational.carter.ide.client.links.RhpLinkWidget", [dijit.layout._LayoutWidget, dijit._Templated], {
	widgetsInTemplate: true,
	//rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),
	templateString: dojo.cache("com.ibm.rational.carter.ide.client", "links/templates/RhpLinkWidget.html"),

	containerNode: null,
	tabContainer: null,
	connectionContainer:null,
	contentPane:null,

	_linkEditor:null,
	_resource: null,
	
	_toolbarContainer:null,
	toolbar:null,
	_headerWidget: null,
	_headerContent: null,


	postCreate: function(){
		this.inherited(arguments);
		//triggers the login window if needed
		if (!RhpCommunicator.login()) {
			return;
		}
		this.createToolbar();
		contextHelper.init();
		var deferred = RhpProjectAreaInfo.init();
		deferred.addCallback(this,this.init);
		

	},


	layout: function(){
		this._content.layout();
		this.inherited(arguments);
	},

	init: function() {
		this.startup();
		this.createConnectionWidget();
		this.layout();
	},
	
	destroyRecursive: function() {
		if(this._connectionWidget){
			   this._connectionWidget.destroyRecursive();
			   delete this._connectionWidget;
			}
			if(this._linkEditor){
				   this._linkEditor.destroyRecursive();
				   delete this._linkEditor;
			}
			
			this.inherited(arguments);
	},

	destroy: function(){
		this.inherited(arguments);
	},

	createConnectionWidget: function() {
		if (!this._connectionWidget) {
			this._connectionWidget = new com.ibm.rational.carter.ide.client.connection.connectionWidget({
				isReadOnly:true,
			});
			this.connectionContainer.appendChild(this._connectionWidget.domNode);
			this._connectionWidget.startup();
			dojo.connect(this._connectionWidget, "_onSelectBaseline",this,this._onSelectBaseline);
			if (this._connectionWidget._currentProjectArea && this._connectionWidget._currentContext)
				this._onSelectBaseline(this._connectionWidget._currentProjectArea, this._connectionWidget._currentContext);
		} 

	},

	
	initResource: function(resourceUri, baseline)
	{
		var deferred = ResourceInfoClient.getResourceInfo(resourceUri,null,baseline);
		deferred.addCallback(this, function(infos){
				this.alertUser("info succeeded");
				this.setResource( (infos != null)? infos[0]:null);
			});
		deferred.addErrback(this,function(err){
			this.alertUser("info failed");
			this.setResource(null);
		});
		return deferred;
	},

	setResource: function(resource)
	{
		this._resource = resource;
		this.updateHeader();
	},
	
	initLinkEditor: function()
	{
		if (this._resource)
		{
			this._linkEditor = new com.ibm.rational.carter.ide.client.links.RhpLinks(
			{	
				resourceInfo: this._resource,
				clmWidget: this,
				editor:this
			});
			this.tabContainer.appendChild(this._linkEditor.domNode);
			this._linkEditor.startup();
		}
		
	},
	
	removeLinkEditor: function()
	{
		if (this._linkEditor)
		{
			this.tabContainer.removeChild(this._linkEditor.domNode);
			this._linkEditor.destroyRecursive();
			delete this._linkEditor;
			this._linkEditor = null;
		}

	},
	
	_onSelectBaseline: function(projectArea, baseline)
	{
		contextHelper.setContext(projectArea, baseline);
		if (projectArea && baseline)
		{
			this.removeLinkEditor();
			var resourceUri = rhpUtils.getFragment("resourceUri");
			var resourceName = rhpUtils.getFragment("resourceName");
			this.setResource({
				resourceContext: projectArea.uri,
				uri: resourceUri,
				shortName: resourceName});
			//var deferred = this.initResource(resourceUri, baseline);
			//deferred.addCallback(this, this.initLinkEditor);
			this.initLinkEditor();
			
		}


	},
	
	showMessage: function(args, closeDelay) {
		if (this.messageBox == null)
			return;
		this._resetMessageCloseDelay();
		
		if (closeDelay == null) {
			delete this.messageBox.__closeDelay;
		} else {
			this.messageBox.__closeDelay =
					parseInt(closeDelay) === closeDelay && closeDelay > 0 ? closeDelay : this.defaultMessageCloseDelay;
		}
				
		if (this.messageBox.__closeTimeout) {
			clearTimeout(this.messageBox.__closeTimeout);
			delete this.messageBox.__closeTimeout;
		}
		this.messageBox.showMessage(args);
		
		dojo.fadeIn({
				node: this.messageBox.domNode
			}).play();
		
		//this.resize(this._lastSize);
		
		this._startMessageCloseDelay();
	},
	
	_startMessageCloseDelay: function() {
		if (this.messageBox.__closeDelay) {
			this.messageBox.__closeTimeout = setTimeout(dojo.hitch(this, this.hideMessage),
				this.messageBox.__closeDelay);
		}
	},
	
	_resetMessageCloseDelay: function() {
		if (this.messageBox.__closeTimeout) {
			clearTimeout(this.messageBox.__closeTimeout);
		}
	},
	
	hideMessage: function() {
		if (this.messageBox == null)
			return;
		
		delete this.messageBox.__closeDelay;
		delete this.messageBox.__closeTimeout;
		dojo.fadeOut({
				node: this.messageBox.domNode,
				onEnd: dojo.hitch(this, function() {
					this.messageBox.hideMessage();
				})
			}).play();
	},
	
	alertUser: function(msg) {
		alert(msg);
	},
	
	addDirty: function(/*String|Object*/key, /*String?*/groupId) {
	},
	
	removeDirty: function(/*String|Object?*/key, /*String?*/groupId) {
	},
	
	updateHeader: function() {
		if (this._headerWidget == null)
		{
			this._headerWidget = new com.ibm.rational.carter.ide.client.header.headerWidget();
			this._headerContent2.appendChild(this._headerWidget.domNode);
			this._resourceNameLbl.innerHTML = "";
		}
		if (this._headerWidget == null)
			return;
		this._headerWidget.setResource(this._resource);
	},

	createToolbar: function()
	{
		if (this.toolbar != null)
			return; 
		this.messageBox = new jazz.ui.MessageBox();
		this._toolbarContainer.appendChild(this.messageBox.domNode);
		
		// toolbar
		this.toolbar = new jazz.ui.SimpleToolbar();
		this.toolbar.containerNode = this.toolbar.domNode;
		
		if (dojo.isIE < 8) {
			this._toolbarContainer.insertBefore(this.toolbar.domNode, this.messageBox.domNode);
		} else {
			this._toolbarContainer.appendChild(this.toolbar.domNode);
		}
		this.addButtons(this.toolbar);
	},

	addButtons: function(toolbar) {
	
		this.refreshButton = toolbar.addButton(this, this._onRefresh, {
				label: commonMessages.refresh,
				imgSrc: dojo.moduleUrl("rmps.app", "graphics/icons/refresh.gif")
			});	
	},

	_onRefresh: function() {
		this.removeLinkEditor();
		this.initLinkEditor();
		
	}

});
})();
