
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
 
 function noError(){return true;}
 
(function() {
	dojo.provide("com.ibm.rational.carter.ide.client.picker.RhpPicker");

/*######################################### */
/*These imports are required to invoke auth dialogs, and
 * users' credentials checking utils. Otherwise, the users,
 * will not be autheroized when trying to search for an element
 * even if they are already logged in */
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");

dojo.require("dijit._Templated");
dojo.require("dijit.layout._LayoutWidget");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.StackController");
dojo.require("dijit._Widget");

dojo.require("com.ibm.rational.carter.ide.client.connection.connectionWidget");

dojo.require("rmps.app.pickers.internal.RMPSPicker");
dojo.require("rmps.app.pickers.internal.PickerController");

dojo.require("rmps.ui.common.TabContainer");

dojo.require("com.ibm.rational.carter.ide.client.context.contextHelper");
contextHelper = com.ibm.rational.carter.ide.client.context.contextHelper;

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;




dojo.declare("com.ibm.rational.carter.ide.client.picker.RhpPicker", [dijit.layout._LayoutWidget, dijit._Templated], {
	widgetsInTemplate: true,
	//rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),
	templateString: dojo.cache("com.ibm.rational.carter.ide.client", "picker/templates/RhpPicker.html"),

	containerNode: null,
	tabContainer: null,
	connectionContainer:null,
	contentPane:null,

	_searchPickerWidget:null,

	postCreate: function(){
		this.inherited(arguments);
		//triggers the login window if needed
		if (!RhpCommunicator.login()) {
			return;
		}
		contextHelper.init();
		var deferred = RhpProjectAreaInfo.init();
		deferred.addCallback(this,this.init);
		

	},


	layout: function(){
		this._content.layout();
		this.inherited(arguments);
	},

	init: function() {
		this.startup();
		this.createConnectionWidget();
		this.layout();
	},
	
	destroy: function(){
		if(this._connectionWidget){
		   this._connectionWidget.destroyRecursive();
		   delete this._connectionWidget;
		}
		if(this._searchPickerWidget){
			   this._searchPickerWidget.destroyRecursive();
			   delete this._searchPickerWidget;
		}
		
		this.inherited(arguments);
	},

	createConnectionWidget: function() {
		if (!this._connectionWidget) {
			this._connectionWidget = new com.ibm.rational.carter.ide.client.connection.connectionWidget({
				isReadOnly:true,
			});
			this.connectionContainer.appendChild(this._connectionWidget.domNode);
			this._connectionWidget.startup();
			dojo.connect(this._connectionWidget, "_onSelectBaseline",this,this._onSelectBaseline);
			if (this._connectionWidget._currentProjectArea && this._connectionWidget._currentContext)
				this._onSelectBaseline(this._connectionWidget._currentProjectArea, this._connectionWidget._currentContext);
		} 

	},


	_onSelectBaseline: function(projectArea, baseline)
	{
		contextHelper.setContext(projectArea, baseline);
		if (projectArea && baseline)
		{
			if (this._searchPickerWidget)
			{
				this.tabContainer.removeChild(this._searchPickerWidget.domNode);
				this._searchPickerWidget.destroyRecursive();
				delete this._searchPickerWidget;
			}

			this._searchPickerWidget = new rmps.app.pickers.internal.RMPSPicker({
				title: "Search",
				projectId: projectArea.itemId,
				context: baseline,
				includeSuppliers: true,
				populateOSLCResponse: false,
				filteredList: [],
				onlyType: "http://jazz.net/ns/dm/rhapsody/uml#Package",
				onlyTypeLabel: "Packages",
				onClose: dojo.hitch(this, this.onSelectResources),
				controller: new com.ibm.rational.carter.ide.client.picker.CLMResourcePicker_Controller()
			});
			this.tabContainer.appendChild(this._searchPickerWidget.domNode);
			this._searchPickerWidget.startup();
			//this.layout();
		}


	},
	
	onSelectResources: function(selections){
		//TO DO: notify Rhapsody About the selection
		var decoded = [];
		 
		if (selections)
		{
			var s = selections.length;
			for (var i = 0; i < s; i++) {
				if (i < s )
					decoded.push(dojo.objectToQuery(selections[i]));
			}
		}
		RhpCommunicator.notifyRhapsody({
			cmd: "pickerselected",
			params:decoded
		});

	},


});

/**
 * Customization of rmps.app.pickers.internal.PickerController that customizes DM resource selection dialog. 
 */
dojo.declare("com.ibm.rational.carter.ide.client.picker.CLMResourcePicker_Controller", rmps.app.pickers.internal.PickerController, {
		
	enableMultiSelect: true,
	allowSearchSystemDomains: false,
	allowEmptySearches: true,
	enableShowAll: true,	
	orderBy: [], // query results are already ordered by name
	pageSize: 10,
	limit: 100, // maximum number of returned results
	limitResultTableHeight: true,
	
	constructor: function(params){
		if (params) {
			if (params.noShowAll) {
				this.allowEmptySearches = false;
				this.enableShowAll = false;
				delete params.noShowAll;
			}
			dojo.mixin(this, params);				
		}
	},
	
	validateQuery: function(queryToExecute) {
		if (this.allowEmptySearches) {
			// parent checks for empty search and returns false in that case, here we want to allow that
			return true;
		} else {
			return this.inherited(arguments);
		}
	},
});

})();
