/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
    dojo.provide("carter.ui.publisher.Publisher");

	dojo.require("jazz.app.context");
    dojo.require("jazz.client.xhr");
    dojo.require("carter.ui.RootServices");
    dojo.require("dojo.parser");
    dojo.require("dojo.io.iframe");
    dojo.require("carter.ui.utils");
    
    var PUBLISH_PATH = carter.ui.RootServices.getUri(carter.ui.Namespaces.CARTER, "publish");
    var BASELINE_PARAM = "rmps.context=";

    carter.ui.publisher.Publisher = {

    	getBaseRequest: function() {
			var baseRequest = PUBLISH_PATH + "?";
			var baseline = jazz.app.context.get().baseline;
			if( baseline ) {
				baseRequest = baseRequest + BASELINE_PARAM + baseline + "&"; 
			}			

			return baseRequest;
        },    
    
        publishZippedModel: function(projectId) {		
            var postRequest = this.getBaseRequest() + "projectId=" + projectId + "&modelName=multipart/form-data";
      		 
            var td = dojo.io.iframe.send({
                url: postRequest,
                form: dojo.byId("ModelUploadForm"),
                handle: function(res, ioArgs) {
                    return ioArgs.xhr.getResponseHeader(Utils.PARAM_ERRORCODE);
                },
                error: function(res, ioArgs) {
                }
            });
        },
    
        publishSampleModel: function(projectId) {
            var baseUri = carter.ui.RootServices.getDMUri("publish");
            var postRequest = baseUri + "?projectId=" + projectId + "&sampleModel=true";

    		var args = {
        			url: postRequest,
                    handleAs: "text",
                	method: "POST",
                    error: function(response, ioArgs){
            		}
        		};
        	
    		return jazz.client.xhrPost(args);
        },

        validatepublishModel: function(projectId) {
    		
            var postRequest = this.getBaseRequest() + "projectId=" + projectId + "&" + "validate=true";
      		 
    		var args = {
        			url: postRequest,
                    handleAs: "text",
                	method: "POST",
                    error: function(response, ioArgs){
            		}
        		};
        	
    		return jazz.client.xhrPost(args);
        }    
    };
    
})();