/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("carter.ui.samples.CreateRhpSampleWizard");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("carter.ui.samples.SampleHelper");
dojo.require("dojo.i18n");

dojo.requireLocalization("carter.ui", "SampleMessages");

/*
 * This class provides the Create RSA Sample section for the JTS Setup Wizard.
 *
 * Author: Cherie Revells
 */
dojo.declare("carter.ui.samples.CreateRhpSampleWizard", [dijit._Widget, dijit._Templated], {

	templateString: '<div dojoAttachPoint="rhpSampleNode" </div>',

	constructor: function(args) {
		this.sampleHelper = new carter.ui.samples.WizardSampleHelper(true, args.wizardStep);
	},
	
	postCreate: function() {
		this.inherited(arguments);
		
		this.sampleHelper.createDetailedProgress();			
		this.startup();
	},
	
	startup: function(){
		this.sampleHelper.progress.render();
		this.rhpSampleNode.appendChild(this.sampleHelper.progress.domNode);
		this.inherited(arguments);
	}
});

/*
 * This class overrides the SampleHelper so that the Next and Finish buttons
 * of the wizard step can be greyed out as the steps are being executed.
 */
dojo.declare("carter.ui.samples.WizardSampleHelper", carter.ui.samples.SampleHelper, {
	
	constructor: function(openLinksInNewTab, wizardStep) {
		this.wizardStep = wizardStep;
	},

	setInProgress: function(state) {
		this.inherited(arguments);
		this.wizardStep.setInProgress(state);
	}
});

})();