/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("carter.ui.samples.WizardActionsRegistery");

dojo.require("rmps.core.error");

carter.ui.samples.WizardActionsRegistery = {

	createSampleUser: function(args, infoArea, detailedProgress) {
		var wizardStep= args.wizardStep;
		var object= dojo.objectToQuery({
			action: "createSampleUser",
			name: wizardStep.getSampleUserName(),
			licenseId: wizardStep.getSampleUserLicenseId()
		});
		RegisterAction(wizardStep, infoArea, detailedProgress,jazz.client.xhrPost, net.jazz.ajax._contextRoot + "/configure?"+object,args.onSuccess, args.onError);
	},

	createProject: function(args, infoArea, detailedProgress) {
		var wizardStep= args.wizardStep;
		var object= dojo.objectToQuery({
			action: "createSampleProject",
			name: wizardStep.getSampleProjectName(),
			userId: wizardStep.getSampleUserId()
		});
		RegisterAction(args.wizardStep, infoArea, detailedProgress,jazz.client.xhrPost, net.jazz.ajax._contextRoot + "/configure?"+object,args.onSuccess, args.onError);
	}

};

/***************************************************************************************************************/
var RegisterAction= function(wizardStep, infoArea, detailedProgress, client, url, onSuccess, onError){
	client({
		url: url,
		headers: {
			"X-ibm-rmps-internal": "true"
		},

		load: function(requestId, ioArgs){
			getRequestDetails(requestId, infoArea, detailedProgress);
			if(onSuccess){
				onSuccess(ioArgs);
			}
		},

		error: function(error, ioargs){
			detailedProgress.notifyErrorAndSupress(infoArea, error.message, true, false);
			if(onError){
				onError(error, ioargs);
			}
		}
	});
};

var getRequestDetails= function(requestId, infoArea, detailedProgress){
	var query = {
		"requestId": requestId,
		"clear": true
	};

	var result = jazz.client.xhrGet({
		url: net.jazz.ajax._contextRoot + "/configure?"+ dojo.objectToQuery(query),
		handleAs: "json",
		headers: {
			"X-ibm-rmps-internal": "true"
		},

		load: function(response){
			if(!response){
				detailedProgress.notifySuccess(infoArea);
				return;
			}
			if(!response.error&& !response.warning){
				if(dojo.trim(response)!= ""){
					detailedProgress.notifyErrorAndSupress(infoArea, responseMessage, true, false);
				}
				detailedProgress.notifySuccess(infoArea);
				return;
			}
			var error= response.error;
			if(error&& error.length>0){
				if(dojo.isArray(error)){
					var all= "";
					for(var index=0 ;index<error.length; index++){
						all= all+ jazz.util.html.escape(error[index])+ "\n \n";
					}
					detailedProgress.notifyErrorAndSupress(infoArea, all, true, false);
				}else{
					detailedProgress.notifyErrorAndSupress(infoArea, jazz.util.html.escape(error), true, false);
				}
			}else{
				var warning= response.warning;
				if(warning&& warning.length>0){
					if(dojo.isArray(warning)){
						var all= "";
						for(var index=0 ;index<warning.length; index++){
							all= all+ jazz.util.html.escape(warning[index])+ "\n \n";
						}
						detailedProgress.notifyWarning(infoArea, all, true, false);
					}else{
						detailedProgress.notifyWarning(infoArea, jazz.util.html.escape(warning[index]));
					}
				}else{
					detailedProgress.notifySuccess(infoArea);
				}
			}
		},

		error: function(error, ioargs){
			detailedProgress.notifyErrorAndSupress(infoArea, error.message, true, false);
		}
	});
};
/***************************************************************************************************************/

})();