/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function() {
	dojo.provide("carter.ui.samples.rhpSamplePage");

	dojo.require("carter.ui.samples.SampleHelper");
	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	dojo.require("dojo.i18n");
	dojo.require("net.jazz.ajax.ui.PlatformUI");

	dojo.requireLocalization("carter.ui", "SampleMessages");

	var PlatformUI = net.jazz.ajax.ui.PlatformUI;

	/*
	 * This class provides the RSA Sample Page for the dm/admin application.
	 *
	 * Author: Cherie Revells
	 */
	dojo.declare("carter.ui.samples.rhpSamplePage", [
			dijit._Widget, dijit._Templated ], {		
		
		"class": "samplePage",

		templateString: dojo.cache("carter.ui", "internal/templates/SamplePage.html"),
		
		sampleHelper: new carter.ui.samples.SampleHelper(),

		constructor : function() {
			this.messages = dojo.i18n.getLocalization("carter.ui", "SampleMessages");
		},
		
		postCreate : function() {
			this.inherited(arguments);

			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("carter.ui.samples.rhpSample", function() {
				// the action must be registered, but we don't need to do anything special
			});
			
			this.sampleHelper.createDetailedProgress();

			this.sampleHelper.progress.render();

			this.mainNode.appendChild(this.sampleHelper.progress.domNode);
		}

	});

}());
