/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
 
 function noError(){return true;}
 
(function() {
dojo.provide("com.ibm.rational.carter.ide.client.search.SearchWidget");
/*######################################### */
/*These imports are required to invoke auth dialogs, and
 * users' credentials checking utils. Otherwise, the users,
 * will not be autheroized when trying to search for an element
 * even if they are already logged in */
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");


dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("dojox.html");
dojo.require("com.ibm.rational.carter.ide.client.search.SearchController");
dojo.require("rmps.app.ui.internal.search.SearchResults");
dojo.require("rmps.app.ui.internal.search.QuickSearch");
dojo.require("dojo.string");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.form.RadioButton");
dojo.require("dijit._Widget");

dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.ui.RemoteChooserResponder");

dojo.require("dojo.hash");

dojo.require("rmps.core.RootServices");

dojo.require("com.ibm.rational.carter.ide.client.context.contextHelper");
var contextHelper = com.ibm.rational.carter.ide.client.context.contextHelper;

dojo.require("rmps.app.ui.internal.util.UrlUtil");
var UrlUtil= rmps.app.ui.internal.util.UrlUtil;

dojo.require("com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient");
var RhpResourceInfoClient = com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient;



//reviews
//dojo.require("rmps.viewlets.internal.reviews.SimpleReviewDetails");
//dojo.require("rmps.viewlets.internal.reviews.ReviewsViewlet");

dojo.require("com.ibm.rational.carter.ide.client.connection.connectionWidget");

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;
var rhpMessages = dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;


/*
 * For now, we would like only to support RadioButton. We have some commented
 * code for the Picker to support nulti-selection; we could uncomment it when
 * needed 
 */
dojo.declare("com.ibm.rational.carter.ide.client.search.SearchWidget", [dijit._Widget, dijit._Templated], {
	
	"class": "root",
	
	messages: dojo.i18n.getLocalization("rmps.app.pickers", "RMPSPickerMessages"),
	rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),
	templateString: dojo.cache("com.ibm.rational.carter.ide.client", "search/templates/SearchWidget.html"),
	
	// private properties
	_controller: null,
	_searchResults: null,
	_quickSearch: null,
	_projectId: null,
	_selectedRows: [],
	_projectArea: null,
	_baseline: null,
	
	_connectionWidget: null,
	
	constructor: function(params){
		window.onerror = noError;
    },
	
	buildRendering: function() {
		this.inherited(arguments);
		this.containerNode = this.domNode;
	},
	
	postCreate: function() {
		
		//triggers the login window if needed
		if (RhpCommunicator.login() == false) {
			return;
		}

		var deferred = RhpProjectAreaInfo.init();
		deferred.addCallback(this,this.init);
		
	},

	initProjectAreaSelection: function(projectName){
		
		this._projectArea = RhpProjectAreaInfo.getProjectAreaByName(projectName);

//		RhpCommunicator.notifyRhapsody({
//				cmd: "projectareaselected",
//				params: (this._projectArea != null)?[this._projectArea.name]:[],
//			});


	},
	
	_onSelectBaseline: function(projectArea, baseline)
	{
		this._projectArea = projectArea;
		this._baseline = baseline;
		if (this._projectArea != null && this._baseline != null) 
		{
			this._quickSearch.setProjectArea(this._projectArea);
			this._quickSearch.setBaseline(this._baseline);
			this.quickSearch.style.visibility = "visible";
		}
		else 
		{
			this.quickSearch.style.visibility = "hidden";
			this._quickSearch.setProjectArea(null);
			this._quickSearch.setBaseline(null);
		}
		contextHelper.setContext(this._projectArea, this._baseline);
	},
			
	init: function() {
		
		contextHelper.init();

		this._controller = new com.ibm.rational.carter.ide.client.search.SearchController(this);
		this._quickSearch = new rmps.app.ui.internal.QuickSearch_({
			_controller: this._controller
			});
			
		this.quickSearch.appendChild(this._quickSearch.domNode);
		this.quickSearch.style.visibility = "hidden";
		
		//this.initProjectAreaSelection(UrlUtil.getActionArgument("projectName"));	
		
		this._connectionWidget = new com.ibm.rational.carter.ide.client.connection.connectionWidget();
		this.connectionContainer.appendChild(this._connectionWidget.domNode);
		
		//dojo.connect(this._connectionWidget, "_onSelectProject",this,this.initProjectAreaSelection); 
		dojo.connect(this._connectionWidget, "_onSelectBaseline",this,this._onSelectBaseline);
		if (this._connectionWidget._currentProjectArea != null && this._connectionWidget._currentContext != null)
			this._onSelectBaseline(this._connectionWidget._currentProjectArea, this._connectionWidget._currentContext);

	
		//subscribe to show in browser event.		
		 dojo.subscribe("rmps.web.app.explorer.show", this, function(resourceUri){
		 	if (resourceUri != null) {
				RhpCommunicator.notifyRhapsody({
					cmd: "ShowInExplorer",
					params:[resourceUri.uri]
				});
			}
 		});

		//subscribe on has change to catch pageSize changes
		dojo.subscribe("/dojo/hashchange", this, "onHashChange");
		
		//to run the search from the url fragment
		this.runSearchFromFragment(dojo.hash());
	},

	onHashChange: function(hash) {
		this.runSearchFromFragment(hash);
	},

	//runs the search from the url fragment
	runSearchFromFragment: function(hash) {

		//var hash = dojo.hash();
		var fragment = dojo.queryToObject(hash);
		if (fragment.query != null && fragment.query != undefined) {
			var query = dojo.queryToObject(fragment.query);
			if (query.projectId != null) {
				var pa = RhpProjectAreaInfo.getProjectAreaById(query.projectId);

				if (pa != null) {
					var value = this._connectionWidget.projectSelector.attr('value',pa.name);
					this.initProjectAreaSelection(pa.name);
				}
			}
			//TO DO: select the project in the drop down list	
			this._controller.search({query: fragment.query});
		}
	},
	
	_handleWindowResize: function(event) {
		setTimeout(dojo.hitch(this, this.resize), 0);
	},
	
	resize: function() {
		/*Empty Block */
	},
	
	destroy: function() {
		if (this._searchResults) {
			
			this._searchResults.destroy();
			this._searchResults = null;
		}
		this.inherited(arguments);
		
	},
	
	
	showSearchResults: function(queryResults, preserveFilter) {
		if (!this._searchResults) { 
			this._searchResults = new rmps.app.ui.internal.search.SearchResults_({
					_quickSearch: this._quickSearch ,
					
					/*checkBoxes: this._selectedRows*/
					});
			this._searchResults.startup();
			this._searchResults.root = this._searchResults.domNode;	
			//this._searchResults._resultTable.onCheckboxChange = dojo.hitch(this , this.onCheckboxChange);
		}
		
		this._searchResults.showResults(queryResults, preserveFilter);
		this.searchResults.appendChild(this._searchResults.domNode);
		
	},
	
	showStatusNode: function(text) {
		this.statusNode.innerHTML = "";
		if (text != null) {
			this.statusNode.appendChild(dojo.doc.createTextNode(text+"..."));	//$NON-NLS-1$
			this.statusNode.style.display= "inline";
		}else {
			this.statusNode.style.display= "none";			
		}
	},
	
	hideStatusNode: function() {
		this.statusNode.innerHTML = "";
		this.statusNode.style.display= "none";
	},
	
});



dojo.declare("rmps.app.ui.internal.search.SearchResults_", rmps.app.ui.internal.search.SearchResults, {
	
	tableClass: "rmps.app.ui.internal.search._TableEx",
	_quickSearch: null,
	_machingLabel: null,
	checkBoxes: null,
	messages: dojo.i18n.getLocalization("rmps.app.pickers", "RMPSPickerMessages"),
	
	createTable: function() {
		var table= this.inherited(arguments);
		table._quickSearch= this._quickSearch;
		return table;
	},

	setTitleNode: function(queryResult, titleNode){
		dojo.html._setNodeContent(titleNode, dojo.doc.createTextNode(queryResult.query.name + " "), true);
	},

	setDescriptionNode: function(queryResult){
		this.inherited(arguments);//dojo.html._emptyNode(this._descriptionNode);
		
	},
	 _exploreTree: function(resourceUri) {
		 	if (resourceUri) {
		 		var deferred = RhpResourceInfoClient._getResourceInfos(resourceUri,["longName"]);
		 		deferred.addCallback(this, function(result) {
		 			var modelName = null;
		 			if (result.length> 0)
		 			{
		 				var longName = result[0].longName;
		 				if (longName)
		 				{
		 					var begin = longName.indexOf('[');
		 					var end = longName.indexOf(']');
		 					if (begin > -1 && end > begin +1)
		 						modelName = longName.substring(begin+1,end);
		 				}
		 				
		 			}
		 			if (modelName)
		 			{
		 				RhpCommunicator.notifyRhapsody({
		 					cmd: "ShowInExplorer",
		 					params:[resourceUri,modelName]
		 				});
		 			}

				});

			}
	}, 
	
});


dojo.declare("rmps.app.ui.internal.search._TableEx", rmps.app.ui.internal.search._Table, {
	
	_quickSearch: null,
	_idToIdx: {},
	_baseLinkUri: null,
	
	_populateTableBody: function() {
		
		if (this._quickSearch != null && this._quickSearch._projectArea != null)
		{
			var PROJECT_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "projects");
			PROJECT_PATH = PROJECT_PATH.replace("projects","web/projects");
			this._baseLinkUri = PROJECT_PATH + "/" + this._quickSearch._projectArea.name + "?rmps.context=" + jazz.app.context.get().baseline;
		}
		this.inherited(arguments);
	},
	
	_populateColumn: function(rowConfig, tableRow, rowIdx, columnConfig, tableCell, colIdx) {

		this.inherited(arguments);
		if (columnConfig.link) {
			var span = tableCell.lastChild;
			var link = span.lastChild;
			var href = new String(link.href);
			href = href.substring(href.lastIndexOf('#'), href.length);
			link.href = this._baseLinkUri + (href);
		}

	},
	
	_handleTbodyMouseClick: function(e) {
		/*We do not allow navigation for the table links in the picker */
		return;
	},
	
	onPreviousClick: function(e) {
		dojo.stopEvent(e);
		this.doQuery(this.pagingControl.page-1, this.pagingControl.pageSize);
	},
	
	onNextClick: function(e) {
		dojo.stopEvent(e);
		this.doQuery(this.pagingControl.page+1, this.pagingControl.pageSize);
	},
	
	doQuery: function(page, pageSize){
		var query= this.createQuery(page, pageSize);
		var queryString= query.toQueryString();
		var timestamp = new Date().getTime();
		this._quickSearch.doQuery(query);
	},
	
	createQuery:function(page, pageSize){
		var queryResult = this.pagingControl.table.search.getQueryResult();
		var query = dojo.clone(queryResult.query);
		query.pageSize = pageSize;
		query.page = page;
		query.token = query.id;
		return query;
	},
	

	
		

});


dojo.declare("rmps.app.ui.internal.QuickSearch_", rmps.app.ui.internal.search.QuickSearch, {
	
    _controller: null,
	pageSize: 5,
	resourcesOnly: false,
	_projectArea: null,

	setProjectArea: function(pa)
	{
		this._projectArea = pa;
		this.projectId = (pa != null) ? pa.itemId: null;
	},
	setBaseline: function(baseline)
	{
		this.baseline = baseline;
	},
	
	doQuery: function(query) {
		this._controller.search({query: query.toQueryString()});
	}
});

})();
